summaryrefslogtreecommitdiff
path: root/tests.as-root/building-a-system-branch-picks-up-uncommitted-changes.script
diff options
context:
space:
mode:
authorJannis Pohlmann <jannis.pohlmann@codethink.co.uk>2012-09-06 17:04:25 +0000
committerSam Thursfield <sam.thursfield@codethink.co.uk>2012-09-07 18:14:45 +0100
commit1684baff0a13471a22f559755fd74748382b6cdb (patch)
treec7d9682039928a68fc60b38f914cee2e16f62fb7 /tests.as-root/building-a-system-branch-picks-up-uncommitted-changes.script
parent085a3455710c722c91368e2d029634f427fb4059 (diff)
downloadmorph-1684baff0a13471a22f559755fd74748382b6cdb.tar.gz
Add test to verify that building a branch picks up uncommitted changes
Diffstat (limited to 'tests.as-root/building-a-system-branch-picks-up-uncommitted-changes.script')
-rwxr-xr-xtests.as-root/building-a-system-branch-picks-up-uncommitted-changes.script71
1 files changed, 71 insertions, 0 deletions
diff --git a/tests.as-root/building-a-system-branch-picks-up-uncommitted-changes.script b/tests.as-root/building-a-system-branch-picks-up-uncommitted-changes.script
new file mode 100755
index 00000000..0942bc82
--- /dev/null
+++ b/tests.as-root/building-a-system-branch-picks-up-uncommitted-changes.script
@@ -0,0 +1,71 @@
+#!/bin/bash
+# Copyright (C) 2012 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+# Make sure "morph build" works anywhere in a workspace or system branch
+# and produces the same results every time.
+
+set -eu
+
+# Initialise the workspace.
+cd "$DATADIR/workspace"
+"$SRCDIR/scripts/test-morph" init
+
+# Create a new local system branch.
+"$SRCDIR/scripts/test-morph" branch test:morphs-repo branch1
+
+# Edit linux.
+"$SRCDIR/scripts/test-morph" edit linux-system linux-stratum linux
+
+# Fix the UUIDs being used for the temporary refs.
+git config -f "$DATADIR/workspace/branch1/.morph-system-branch/config" \
+ branch.uuid 123456789
+git config -f "$DATADIR/workspace/branch1/test:morphs-repo/.git/config" \
+ morph.uuid 987654321
+git config -f "$DATADIR/workspace/branch1/test:kernel-repo/.git/config" \
+ morph.uuid AABBCCDDE
+
+# Build the linux system from the system branch.
+cd "$DATADIR/workspace"
+"$SRCDIR/scripts/test-morph" build linux-system
+
+# Print tree SHA1s of the build ref of morphs and kernel.
+echo "Tree of morphs repo build branch after first build:"
+cd "$DATADIR/workspace/branch1/test:morphs-repo"
+git log -1 --format=%T baserock/builds/123456789/987654321
+echo "Tree of kernel repo build branch after first build:"
+cd "$DATADIR/workspace/branch1/test:kernel-repo"
+git log -1 --format=%T baserock/builds/123456789/AABBCCDDE
+
+echo
+
+# Make an uncommitted change to the linux morphology.
+cd "$DATADIR/workspace/branch1/test:kernel-repo"
+sed -i -e 's@touch@touch foo@g' linux.morph
+
+# Build the linux system again without comitting.
+cd "$DATADIR/workspace"
+"$SRCDIR/scripts/test-morph" build linux-system
+
+# Print tree SHA1s of the build ref of morphs and kernel again.
+# This time the tree SHA1 of morphs-repo should be the same
+# but that of the kernel repo should be different because we
+# made a change.
+echo "Tree of morphs repo build branch after second build:"
+cd "$DATADIR/workspace/branch1/test:morphs-repo"
+git log -1 --format=%T baserock/builds/123456789/987654321
+echo "Tree of kernel repo build branch after second build:"
+cd "$DATADIR/workspace/branch1/test:kernel-repo"
+git log -1 --format=%T baserock/builds/123456789/AABBCCDDE